BTCPayServer/Controllers/StoresController.cs
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Net.Http;
using System.Threading;
using System.Threading.Tasks;
using BTCPayServer.Abstractions.Constants;
using BTCPayServer.Abstractions.Extensions;
using BTCPayServer.Abstractions.Models;
using BTCPayServer.Client;
using BTCPayServer.Configuration;
using BTCPayServer.Data;
using BTCPayServer.HostedServices;
using BTCPayServer.Models;
using BTCPayServer.Models.StoreViewModels;
using BTCPayServer.Payments;
using BTCPayServer.Payments.Lightning;
using BTCPayServer.Rating;
using BTCPayServer.Security;
using BTCPayServer.Security.Bitpay;
using BTCPayServer.Services;
using BTCPayServer.Services.Apps;
using BTCPayServer.Services.Invoices;
using BTCPayServer.Services.Rates;
using BTCPayServer.Services.Shopify;
using BTCPayServer.Services.Stores;
using BTCPayServer.Services.Wallets;
using BundlerMinifier.TagHelpers;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using NBitcoin;
using NBitcoin.DataEncoders;
using NBXplorer;
using StoreData = BTCPayServer.Data.StoreData;

namespace BTCPayServer.Controllers
{
    [Route("stores")]
    [Authorize(AuthenticationSchemes = AuthenticationSchemes.Cookie)]
    [Authorize(Policy = Policies.CanModifyStoreSettings, AuthenticationSchemes = AuthenticationSchemes.Cookie)]
    [AutoValidateAntiforgeryToken]
    public partial class StoresController : Controller
    {
        readonly RateFetcher _RateFactory;
        public string CreatedStoreId { get; set; }
        public StoresController(
            IServiceProvider serviceProvider,
            BTCPayServerOptions btcpayServerOptions,
            BTCPayServerEnvironment btcpayEnv,
            StoreRepository repo,
            TokenRepository tokenRepo,
            UserManager<ApplicationUser> userManager,
            AccessTokenController tokenController,
            BTCPayWalletProvider walletProvider,
            BTCPayNetworkProvider networkProvider,
            RateFetcher rateFactory,
            ExplorerClientProvider explorerProvider,
            LanguageService langService,
            PaymentMethodHandlerDictionary paymentMethodHandlerDictionary,
            SettingsRepository settingsRepository,
            IAuthorizationService authorizationService,
            EventAggregator eventAggregator,
            CssThemeManager cssThemeManager,
            AppService appService,
            IWebHostEnvironment webHostEnvironment,
            WebhookNotificationManager webhookNotificationManager)
        {
            _RateFactory = rateFactory;
            _Repo = repo;
            _TokenRepository = tokenRepo;
            _UserManager = userManager;
            _LangService = langService;
            _TokenController = tokenController;
            _WalletProvider = walletProvider;
            _paymentMethodHandlerDictionary = paymentMethodHandlerDictionary;
            _settingsRepository = settingsRepository;
            _authorizationService = authorizationService;
            _CssThemeManager = cssThemeManager;
            _appService = appService;
            _webHostEnvironment = webHostEnvironment;
            WebhookNotificationManager = webhookNotificationManager;
            _EventAggregator = eventAggregator;
            _NetworkProvider = networkProvider;
            _ExplorerProvider = explorerProvider;
            _ServiceProvider = serviceProvider;
            _BtcpayServerOptions = btcpayServerOptions;
            _BTCPayEnv = btcpayEnv;
        }

        readonly BTCPayServerOptions _BtcpayServerOptions;
        readonly BTCPayServerEnvironment _BTCPayEnv;
        readonly IServiceProvider _ServiceProvider;
        readonly BTCPayNetworkProvider _NetworkProvider;
        private readonly ExplorerClientProvider _ExplorerProvider;
        readonly BTCPayWalletProvider _WalletProvider;
        readonly AccessTokenController _TokenController;
        readonly StoreRepository _Repo;
        readonly TokenRepository _TokenRepository;
        readonly UserManager<ApplicationUser> _UserManager;
        private readonly LanguageService _LangService;
        private readonly PaymentMethodHandlerDictionary _paymentMethodHandlerDictionary;
        private readonly SettingsRepository _settingsRepository;
        private readonly IAuthorizationService _authorizationService;
        private readonly CssThemeManager _CssThemeManager;
        private readonly AppService _appService;
        private readonly IWebHostEnvironment _webHostEnvironment;
        private readonly EventAggregator _EventAggregator;

        [TempData]
        public bool StoreNotConfigured
        {
            get; set;
        }

        [HttpGet]
        [Route("{storeId}/users")]
        public async Task<IActionResult> StoreUsers()
        {
            StoreUsersViewModel vm = new StoreUsersViewModel();
            await FillUsers(vm);
            return View(vm);
        }

        private async Task FillUsers(StoreUsersViewModel vm)
        {
            var users = await _Repo.GetStoreUsers(CurrentStore.Id);
            vm.StoreId = CurrentStore.Id;
            vm.Users = users.Select(u => new StoreUsersViewModel.StoreUserViewModel()
            {
                Email = u.Email,
                Id = u.Id,
                Role = u.Role
            }).ToList();
        }

        public StoreData CurrentStore
        {
            get
            {
                return this.HttpContext.GetStoreData();
            }
        }


        [HttpPost]
        [Route("{storeId}/users")]
        public async Task<IActionResult> StoreUsers(StoreUsersViewModel vm)
        {
            await FillUsers(vm);
            if (!ModelState.IsValid)
            {
                return View(vm);
            }
            var user = await _UserManager.FindByEmailAsync(vm.Email);
            if (user == null)
            {
                ModelState.AddModelError(nameof(vm.Email), "User not found");
                return View(vm);
            }
            if (!StoreRoles.AllRoles.Contains(vm.Role))
            {
                ModelState.AddModelError(nameof(vm.Role), "Invalid role");
                return View(vm);
            }
            if (!await _Repo.AddStoreUser(CurrentStore.Id, user.Id, vm.Role))
            {
                ModelState.AddModelError(nameof(vm.Email), "The user already has access to this store");
                return View(vm);
            }
            TempData[WellKnownTempData.SuccessMessage] = "User added successfully";
            return RedirectToAction(nameof(StoreUsers));
        }

        [HttpGet]
        [Route("{storeId}/users/{userId}/delete")]
        public async Task<IActionResult> DeleteStoreUser(string userId)
        {
            StoreUsersViewModel vm = new StoreUsersViewModel();
            var user = await _UserManager.FindByIdAsync(userId);
            if (user == null)
                return NotFound();
            return View("Confirm", new ConfirmModel()
            {
                Title = $"Remove store user",
                Description = $"Are you sure you want to remove store access for {user.Email}?",
                Action = "Delete"
            });
        }

        [HttpPost]
        [Route("{storeId}/users/{userId}/delete")]
        public async Task<IActionResult> DeleteStoreUserPost(string storeId, string userId)
        {
            await _Repo.RemoveStoreUser(storeId, userId);
            TempData[WellKnownTempData.SuccessMessage] = "User removed successfully";
            return RedirectToAction(nameof(StoreUsers), new { storeId = storeId, userId = userId });
        }

        [HttpGet]
        [Route("{storeId}/rates")]
        public IActionResult Rates()
        {
            var exchanges = GetSupportedExchanges();
            var storeBlob = CurrentStore.GetStoreBlob();
            var vm = new RatesViewModel();
            vm.SetExchangeRates(exchanges, storeBlob.PreferredExchange ?? CoinGeckoRateProvider.CoinGeckoName);
            vm.Spread = (double)(storeBlob.Spread * 100m);
            vm.StoreId = CurrentStore.Id;
            vm.Script = storeBlob.GetRateRules(_NetworkProvider).ToString();
            vm.DefaultScript = storeBlob.GetDefaultRateRules(_NetworkProvider).ToString();
            vm.AvailableExchanges = exchanges;
            vm.DefaultCurrencyPairs = storeBlob.GetDefaultCurrencyPairString();
            vm.ShowScripting = storeBlob.RateScripting;
            return View(vm);
        }

        [HttpPost]
        [Route("{storeId}/rates")]
        public async Task<IActionResult> Rates(RatesViewModel model, string command = null, string storeId = null, CancellationToken cancellationToken = default)
        {
            if (command == "scripting-on")
            {
                return RedirectToAction(nameof(ShowRateRules), new { scripting = true, storeId = model.StoreId });
            }
            else if (command == "scripting-off")
            {
                return RedirectToAction(nameof(ShowRateRules), new { scripting = false, storeId = model.StoreId });
            }

            var exchanges = GetSupportedExchanges();
            model.SetExchangeRates(exchanges, model.PreferredExchange);
            model.StoreId = storeId ?? model.StoreId;
            CurrencyPair[] currencyPairs = null;
            try
            {
                currencyPairs = model.DefaultCurrencyPairs?
                     .Split(new[] { ',' }, StringSplitOptions.RemoveEmptyEntries)
                     .Select(p => CurrencyPair.Parse(p))
                     .ToArray();
            }
            catch
            {
                ModelState.AddModelError(nameof(model.DefaultCurrencyPairs), "Invalid currency pairs (should be for example: BTC_USD,BTC_CAD,BTC_JPY)");
            }
            if (!ModelState.IsValid)

BTCPayServer/Views/Shared/CameraScanner.cshtml
<div id="camera-qr-scanner-modal-app" v-cloak class="only-for-js">
    <div class="modal fade" data-backdrop="static" :id="modalId">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">
                        {{title}}
                        <span v-if="workload.length > 0">Animated QR detected: {{workload.length}} / {{workload[0].total}} scanned</span>
                    </h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close" v-on:click="close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body p-0" v-if="loaded" v-bind:class="{'alert-danger': errorMessage}">
                    <qrcode-drop-zone v-on:decode="onDecode" v-on:init="logErrors">
                        <qrcode-stream v-on:decode="onDecode" v-on:init="onInit" v-bind:camera="camera" v-bind:track="paint">
                            <div v-if="data || errorMessage" class="pending-action">

                                <div class="text-danger p-2" v-if="errorMessage">{{errorMessage}}</div>
                                <span class="text-muted text-truncate">{{data}}</span>
                                <div class="w-100 btn-group">
                                    <button v-if="data" type="button" class="btn btn-primary" data-dismiss="modal" v-on:click="submitData">Submit</button>
                                    <button type="button" class="btn btn-secondary" v-on:click="retry">Retry</button>
                                    <button type="button" class="btn btn-danger" data-dismiss="modal" v-on:click="close">Cancel</button>
                                </div>
                            </div>
                        </qrcode-stream>
                    </qrcode-drop-zone>
                    <qrcode-capture v-if="noStreamApiSupport" v-on:decode="onDecode" v-bind:camera="camera"/>
                </div>
            </div>
        </div>
    </div>
</div>
<style>
    .pending-action {
        position: absolute;
        width: 100%;
        height: 100%;        
        background-color: rgba(255, 255, 255, .8);
        text-align: center;
        font-size: 1.4rem;
        padding: 10px;
        word-wrap: break-word;        
        display: flex;
        flex-flow: column nowrap;
        justify-content: center;
    }
</style>


<script>
function initCameraScanningApp(title, onDataSubmit, modalId)
{

	new Vue(
	{
		el: '#camera-qr-scanner-modal-app',
		data:
		{
			noStreamApiSupport: false,
			loaded: false,
			workload: [],
			data: "",
			title: title,
			errorMessage: "",
			modalId: modalId
		},
		mounted: function ()
		{
			var self = this;
			$("#" + this.modalId)
				.on("shown.bs.modal", function ()
				{
					self.loaded = true;
				})
				.on("hide.bs.modal", function ()
				{
					self.close();
				});
		},
		computed:
		{
			camera: function ()
			{
				return this.data ? "off" : "auto";
			}
		},
		methods:
		{
			retry: function ()
			{
				if (!this.data)
				{
					this.close();
					this.$nextTick(function ()
					{
						this.loaded = true;
					});
					return;
				}
				this.data = "";
				this.workload = [];
				this.errorMessage = "";
			},
			close: function ()
			{
				this.loaded = false;
				this.data = "";
				this.workload = [];
				this.errorMessage = "";
			},
			onDecode: function (content)
			{
				if (this.data)
				{
					return;
				}
				if (!content.toLowerCase().startsWith("ur:"))
				{
					this.data = content;
					this.workload = [];
				}
				else
				{
					const [index, total] = window.bcur.extractSingleWorkload(content);
					if (this.workload.length > 0)
					{
						const currentTotal = this.workload[0].total;
						if (total !== currentTotal)
						{
							this.workload = [];
						}
					}
					if (!this.workload.find(i => i.index === index))
					{
						this.workload.push(
						{
							index,
							total,
							data: content,
						});
						if (this.workload.length === total)
						{
							this.data = window.bcur.decodeUR(this.workload.map(i => i.data));
						}
					}
				}
			},
			submitData: function ()
			{
				if (onDataSubmit)
				{
					onDataSubmit(this.data);
				}
				this.close();
			},
			logErrors: function (promise)
			{
				promise.catch(console.error)
			},
			paint: function (location, ctx)
			{
				ctx.fillStyle = '#137547';
				[
					location.topLeftFinderPattern,
					location.topRightFinderPattern,
					location.bottomLeftFinderPattern
				].forEach((
				{
					x,
					y
				}) =>
				{
					ctx.fillRect(x - 5, y - 5, 10, 10);
				})
			},
			onInit: function (promise)
			{
				var self = this;
				promise.then(() =>
					{
						self.errorMessage = "";
					})
					.catch(error =>
					{
						if (error.name === 'StreamApiNotSupportedError')
						{
							self.noStreamApiSupport = true;
						}
						else if (error.name === 'NotAllowedError')
						{
							self.errorMessage = 'A permission to the camera is needed to scan the QR code.'
						}
						else if (error.name === 'NotFoundError')
						{
							self.errorMessage = 'A camera was not detected on your device.'
						}
						else if (error.name === 'NotSupportedError')
						{
							self.errorMessage = 'This page is served in non-secure context (HTTPS, localhost or file://)'
						}
						else if (error.name === 'NotReadableError')
						{
							self.errorMessage = 'Couldn\'t access your camera. Is it already in use?'
						}
						else if (error.name === 'OverconstrainedError')
						{
							self.errorMessage = 'Constraints don\'t match any installed camera.'
						}
						else
						{
							self.errorMessage = 'UNKNOWN ERROR: ' + error.message
						}
					})
			}
		}
	});
}
</script>

BTCPayServer/Views/Shared/Confirm.cshtml
@model ConfirmModel

@{
    ViewData["Title"] = Model.Title;
    Layout = null;
}

<!DOCTYPE html>
<html lang="en">
<head>
    <partial name="Header" />
</head>
<body class="bg-light">
    <div class="modal-dialog modal-dialog-centered">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title w-100 text-center">@Model.Title</h4>
            </div>

            <div class="modal-body text-center">
                @if (Model.DescriptionHtml)
                {
                    @Safe.Raw(Model.Description)
                }
                else
                {
                    @Model.Description
                }
            </div>

            @if (!String.IsNullOrEmpty(Model.Action))
            {
                <form method="post" class="modal-footer justify-content-center" action="@Model.ActionUrl">
                    <button type="submit" class="btn @Model.ButtonClass w-25 mx-2" id="continue">@Model.Action</button>
                    <button type="submit" class="btn btn-secondary w-25 mx-2" onclick="history.back(); return false;">Go back</button>
                </form>
            }
        </div>
    </div>
</body>
</html>

BTCPayServer/Views/Shared/EmailsBody.cshtml
@model BTCPayServer.Models.ServerViewModels.EmailsViewModel


<partial name="_StatusMessage" />

<div class="row">
    <div class="col-md-6">
        <div asp-validation-summary="All" class="text-danger"></div>
    </div>
</div>

<div class="row row-quick-fill" style="display: none">
    <div class="col-sm-6">
        <div class="dropdown quick-fill">
            <button class="btn btn-primary dropdown-toggle" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                Quick fill settings for...
            </button>
            <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                <a class="dropdown-item" href="" data-Server="smtp.gmail.com" data-Port="587" data-EnableSSL="true">Gmail.com</a>
                <a class="dropdown-item" href="" data-Server="mail.yahoo.com" data-Port="587" data-EnableSSL="true">Yahoo.com</a>
                <a class="dropdown-item" href="" data-Server="smtp.mailgun.org" data-Port="587" data-EnableSSL="true">Mailgun</a>
                <a class="dropdown-item" href="" data-Server="smtp.office365.com" data-Port="587" data-EnableSSL="true">Office365</a>
                <a class="dropdown-item" href="" data-Server="smtp.sendgrid.net" data-Port="587" data-EnableSSL="true">SendGrid</a>
            </div>
        </div>
        <p></p>
    </div>
</div>
<script>
    $(document).ready(function () {
        $('.row-quick-fill').show();

        $('.dropdown.quick-fill a').click(function (e) {
            e.preventDefault();

            var aNode = $(this);
            var data = aNode.data();

            for (var key in data) {
                var value = data[key];
                var inputNodes = $('input[name*="Settings.' + key + '" i]');

                if (inputNodes.length) {
                    inputNodes.each(function (i, input) {
                        input = $(input);
                        var type = input.attr('type');
                        if (type === 'checkbox') {
                            input.prop('checked', value);

                        } else {
                            input.val(value);
                        }
                    });

                }
            }
        });

    });
</script>

<form method="post" autocomplete="off">
    <div class="row">
        <div class="col-md-6">
            <div class="form-group">
                <label asp-for="Settings.Server"></label>
                <input asp-for="Settings.Server" class="form-control" />
                <span asp-validation-for="Settings.Server" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Settings.Port"></label>
                <input asp-for="Settings.Port" class="form-control" />
                <span asp-validation-for="Settings.Port" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Settings.FromDisplay"></label>
                <input asp-for="Settings.FromDisplay" class="form-control" />
                <small class="form-text text-muted">
                    Some email providers (like Gmail) don't allow you to set your display name, so this setting may not have any effect.
                </small>
                <span asp-validation-for="Settings.FromDisplay" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Settings.From"></label>
                <input asp-for="Settings.From" class="form-control" />
                <span asp-validation-for="Settings.From" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Settings.Login"></label>
                <input asp-for="Settings.Login" class="form-control" />
                <small class="form-text text-muted">
                    For many email providers (like Gmail) your login is your email address.
                </small>
                <span asp-validation-for="Settings.Login" class="text-danger"></span>
            </div>
            <div class="form-group">
                @if (!Model.PasswordSet)
                {

                    <label asp-for="Settings.Password"></label>
                    <input asp-for="Settings.Password" type="password" class="form-control" />
                    <span asp-validation-for="Settings.Password" class="text-danger"></span>
                }
                else
                {
                    <label asp-for="Settings.Password"></label>
                    <div class="input-group">
                        <input value="Configured" type="text" readonly class="form-control" />
                        <div class="input-group-append">
                            <button type="submit" class="btn btn-danger" name="command" value="ResetPassword">Reset</button>
                        </div>
                    </div>
                }
            </div>
            <div class="form-group">
                <div class="form-check">
                    <input asp-for="Settings.EnableSSL" type="checkbox" class="form-check-input" />
                    <label asp-for="Settings.EnableSSL" class="form-check-label"></label>
                </div>
            </div>
            <input asp-for="PasswordSet" type="hidden" />
            <button type="submit" class="btn btn-primary" name="command" value="Save">Save</button>
        </div>
    </div>

    <hr class="mt-5 mb-4" />

    <div class="row">
        <div class="col-md-6">
            <div class="form-group">
                <p class="form-text text-muted">
                    If you want to test your settings, enter an email address here and click "Send Test Email".
                    <strong>Your settings won't be saved</strong>, only a test email will be sent.
                    <br />
                    After a successful test, you can click "Save".
                </p>
                <label asp-for="TestEmail"></label>
                <input asp-for="TestEmail" class="form-control" />
                <span asp-validation-for="TestEmail" class="text-danger"></span>
            </div>
            <button type="submit" class="btn btn-secondary" name="command" value="Test">Send Test Email</button>
        </div>
    </div>
</form>

@section Scripts {
    @await Html.PartialAsync("_ValidationScriptsPartial")
}

BTCPayServer/Views/Shared/Header.cshtml
@inject BTCPayServer.HostedServices.CssThemeManager themeManager
@addTagHelper *, BundlerMinifier.TagHelpers

<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<meta name="description" content="">
<meta name="author" content="">
@if (themeManager.DiscourageSearchEngines)
{
<meta name="robots" content="noindex">
}
<title>@ViewData["Title"]</title>
@* CSS *@
<link href="@this.Context.Request.GetRelativePathOrAbsolute(themeManager.BootstrapUri)" rel="stylesheet" asp-append-version="true" />
<link href="@this.Context.Request.GetRelativePathOrAbsolute(themeManager.CreativeStartUri)" rel="stylesheet" asp-append-version="true" />
<link href="@this.Context.Request.GetRelativePathOrAbsolute(themeManager.ThemeUri)" rel="stylesheet" asp-append-version="true" />
@if (!String.IsNullOrWhiteSpace(themeManager.CustomThemeUri))
{
<link href="@this.Context.Request.GetRelativePathOrAbsolute(themeManager.CustomThemeUri)" rel="stylesheet" asp-append-version="true" />
}
<bundle name="wwwroot/bundles/main-bundle.min.css" asp-append-version="true" />
@* JS *@
<bundle name="wwwroot/bundles/main-bundle.min.js" asp-append-version="true" />
@* Non-JS *@
<noscript>
    <style>
        .hide-when-js, [v-cloak] { display: block !important; }
        .only-for-js { display: none !important; }
    </style>
</noscript>

BTCPayServer/Views/Shared/NotificationEmailWarning.cshtml
<div class="alert alert-warning alert-dismissible">
    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
        <span aria-hidden="true">&times;</span>
    </button>The Email settings have not been configured on this server or store yet. Setting this field will not send emails until then. <a asp-action="Emails" asp-controller="Stores" asp-route-storeId="@Model" class="alert-link">Configure store email settings</a>
</div>

BTCPayServer/Views/Shared/PostRedirect.cshtml
@model PostRedirectViewModel
@{ 
    Layout = null;

    var routeData = Context.GetRouteData();
    var routeParams = new Dictionary<string, string>();
    if (routeData != null)
    {
        routeParams["walletId"] = routeData.Values["walletId"]?.ToString();
    }
    var action = Model.FormUrl ?? Url.Action(Model.AspAction, Model.AspController, routeParams);
}

<html lang="en">
<head>
    <partial name="Header" />
    <title>Post Redirect</title>
</head>
<body>
    <form method="post" id="postform" action="@action">
        @Html.AntiForgeryToken()
        @foreach (var o in Model.Parameters)
        {
            <input type="hidden" name="@o.Key" value="@o.Value"/>
        }
        <noscript>
            <div class="modal-dialog modal-dialog-centered">
                <div class="modal-content">
                    <div class="modal-body text-center my-3">
                        <p>
                            This redirection page is supposed to be submitted automatically.
                            <br>
                            Since you have not enabled JavaScript, please submit manually.
                        </p>
                        <button class="btn btn-primary" type="submit">Submit</button>
                    </div>
                </div>
            </div>
        </noscript>
    </form>
    <script type="text/javascript">
        document.forms.item(0).submit();
    </script>
</body>
</html>

BTCPayServer/Views/Shared/ShowQR.cshtml
<div id="scan-qr-modal-app">
    <div class="modal" tabindex="-1" role="dialog" :id="modalId">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">{{title}} <template v-if="fragments.length > 1">({{index+1}}/{{fragments.length}})</template></h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body ">
                    <div class="qr-container text-center" style="min-height: 256px;">
                        <qrcode v-bind:value="currentFragment" :options="{ width: 256,height:256, margin: 1, color: {dark:'#000', light:'#f5f5f7'} }">
                        </qrcode>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>
</div>
<script> 
 function initQRShow(title, data, modalId)
 {
 	return new Vue(
 	{
 		el: '#scan-qr-modal-app',
 		components:
 		{
 			qrcode: VueQrcode
 		},
 		data:
 		{
 			index: -1,
 			title: title,
 			speed: 500,
 			data: data,
 			fragments: [],
 			active: false,
 			modalId: modalId
 		},
 		computed:
 		{
 			currentFragment: function ()
 			{
 				return this.fragments[this.index];
 			}
 		},
 		mounted: function ()
 		{
 			var self = this;
 			$("#" + this.modalId)
 				.on("shown.bs.modal", function ()
 				{
 					self.start();
 				})
 				.on("hide.bs.modal", function ()
 				{
 					self.active = false;
 				});
 			self.setFragments();
 		},
 		watch:
 		{
 			data: function ()
 			{
 				this.setFragments();
 			}
 		},
 		methods:
 		{
 			setFragments: function ()
 			{
 				if (!this.data)
 				{
 					this.fragments = [];
 					return;
 				}
 				this.fragments = window.bcur.encodeUR(this.data.toString(), 200);
 			},
 			start: function ()
 			{
 				this.active = true;
 				this.index = -1;
 				this.playNext();
 			},
 			playNext: function ()
 			{
 				if (!this.active)
 				{
 					return;
 				}
 				this.index++;
 				if (this.index > (this.fragments.length - 1))
 				{
 					this.index = 0;
 				}
 				setTimeout(this.playNext, this.speed)
 			}
 		}
 	});
 }
 </script>

BTCPayServer/Views/Shared/_LayoutSimple.cshtml
@{
    Layout = null;
}
<!DOCTYPE html>
<html lang="en">
<head>
    <partial name="Header" />
</head>
<body>
    <section class="content-wrapper">
        <!-- Dummy navbar-brand, hackish way to keep test AssertNoError passing -->
        <div class="navbar-brand d-none"></div>
        <div class="container">
            @RenderBody()
        </div>
    </section>
    @await Html.PartialAsync("_ValidationScriptsPartial")
</body>
</html>